import es, playerlib, os.path, string, pickle, ojiiupdater, urllib2

info = es.AddonInfo()
info.name	 = "Ojii's Clantag Protector"
info.version  = "1.1.0"
info.url	  = "http://addons.eventscripts.com/addons/view/ocp"
info.author   = "Ojii"
info.basename = "ocp"

updateurl = "http://www.gkclan.com/members/uploads/01112@ocp.update"

path = es.getAddonPath('')
path = path.replace('\\','/')
cfgfile = path.replace('addons/eventscripts/','cfg/ocp_config.cfg')

templist = []	
warninggsdict = {}
adminsdict = {}
commentdict = {}
warningsfile = es.getAddonPath('ocp').replace('\\','/') + '/warnings.pkl'
separator = ';'
comment = '//'
ocp_sid = []
ocp_names = []
test = ''
temp = []
temp2 = ''
temp3 = []
banfile = es.getAddonPath('ocp').replace('\\','/') + '/bans'

def load():
	global adminfile
	es.dbgmsg(0, '[OCP] Loading...')
	es.msg('#multi', '#green [OCP] #default Loading...')
	es.dbgmsg(0, '[OCP] Regristring commands...')
	
	if not es.exists('clientcommand', 'ocp_selfreg'):
		es.regclientcmd('ocp_selfreg', 'ocp/ocp_selfreg')
	if not es.exists('command','ocp_ban'):
		es.regcmd('ocp_ban','ocp/ban')
	if not es.exists('command','ocp_unban'):
		es.regcmd('ocp_unban','ocp/unban')
	if not es.exists('command', 'ocp_reg'):
		es.regcmd('ocp_reg', 'ocp/ocp_reg')
	if not es.exists('command', 'ocp_regplayer'):
		es.regcmd('ocp_regplayer', 'ocp/ocp_regplayer')
	if not es.exists('command', 'ocp_unreg'):
		es.regcmd('ocp_unreg', 'ocp/ocp_unreg')
	if not es.exists('clientcommand','ocp_update'):
		es.regclientcmd('ocp_update','ocp/update')
	for x in range(0,33):
		if not es.exists('command', 'c' + str(x)):
			es.regcmd('c' + str(x), 'ocp/ocp_choice')
	es.dbgmsg(0, '[OCP] Getting configs...')
	if not os.path.lexists(cfgfile):
		get_configs()
	else:
		configs()
	
	if not os.path.lexists(banfile):
		banlist = []
		f = open(banfile,'wb')
		pickle.dump(banlist,f)
		f.close()
	else:
		get_banlist()
	if not os.path.lexists(warningsfile):
		warningsdict = {}
		f = open(warningsfile,'wb')
		pickle.dump(warningsdict,f)
		f.close()
		
	es.dbgmsg(0, '[OCP] Loaded...')
	es.msg('#multi', '#green [OCP] #default Loaded...')
	es.msg('#multi', '#green [OCP] #default This server is using Ojii Clantag Protector ' + info.version)
	es.msg('#multi', '#green [OCP] #default Following clantags are protected:')
	clantagstring = ''
	tags = len(clantaglist) / 4
	for x in range(0,tags):
		clantagstring = clantagstring + clantaglist[(x * 4) - 1] + ', '
	clantagstring = clantagstring[:-2]
	es.msg('#multi', '#green [OCP] #default ' + clantagstring)
	
def unload():
	es.unregclientcmd('ocp_selfreg')
	es.unregclientcmd('ocp_update')
	es.dbgmsg(0, '[OCP] Unloaded...')
	es.msg('#multi', '#green [OCP] #default Unloaded...')
		
def player_activate (event_var):
	global adminsdict, warningsdict
	steamid = event_var['es_steamid']
	name = event_var['es_username']
	read_admins()
	read_warnings()
	if checkclantag(name):
		if not adminsdict.has_key(steamid):
			es.server.cmd('kickid ' + event_var['userid'] + ' Clantag protection')
			if warningsdict.has_key(steamid):
				if warningsdict[steamid] == limit:
					es.server.cmd('banid 0 ' + steamid + ' kick')
					es.server.cmd('writeid 0 ' + steamid)
				else:
					warningsdict[steamid] = warningsdict[steamid] + 1
			else:
				warningsdict[steamid] = 1
	write_warnings()
	
def player_changename(event_var):
	global adminsdict, warningsdict
	userid = event_var['userid']
	steamid = es.getplayersteamid(userid)
	name = event_var['newname']
	read_admins()
	read_warnings()
	if checkclantag(name):
		if not adminsdict.has_key(steamid):
			es.server.cmd('kickid ' + event_var['userid'] + ' Clantag protection')
			if warningsdict.has_key(steamid):
				if warningsdict[steamid] == limit:
					es.server.cmd('banid 0 ' + steamid + ' kick')
					es.server.cmd('writeid 0 ' + steamid)
				else:
					warningsdict[steamid] = warningsdict[steamid] + 1
			else:
				warningsdict[steamid] = 1
	write_warnings()
	
def checkclantag(name):
	for tag in clantaglist:
		if name.replace(' ','').startswith(tag):
			return True
		elif name.replace(' ','').endswith(tag):
			return True
		elif name.startswith(tag):
			return True
		elif name.endswith(tag):
			return True
		elif name.count(tag) == 1:
			return True
	return False
	
def read_admins():
	global adminsdict
	tempfile = open(adminfile, 'r')
	lines = tempfile.read().splitlines()
	tempfile.close()
	x = 0
	for line in lines:
		if not line.startswith(comment):
			splitted = line.split(separator)
			adminsdict[splitted[0].replace(' ','')] = (splitted[1].replace(' ',''))

def write_admins():
	global adminsdict
	tempfile = open(adminfile, 'r')
	lines = tempfile.read().splitlines()
	tempfile.close()
	ws = ''
	n = '\n'
	list = []
	for line in lines:
		if line.startswith(comment):
			ws = ws + line + n
		else:
			splitted = line.split(separator)
			if adminsdict.has_key(splitted[0].replace(' ','')):
				ws = ws + splitted[0] + separator + adminsdict[splitted[0]] + n
				list.append(splitted[0])
	for admin in adminsdict:
		if admin not in list:
			ws = ws + admin + separator + adminsdict[admin] + n
	tempfile = open(adminfile, 'w')
	tempfile.write(ws[:-1])
	tempfile.close()

def read_warnings():
	global warningsdict
	f = open(warningsfile,'rb')
	warningsdict = pickle.load(f)
	f.close()
	
def write_warnings():
	f = open(warningsfile,'wb')
	pickle.dump(warningsdict,f)
	f.close()
	
def ocp_selfreg():
	global adminsdict, warningsdict, linecount
	read_admins()
	read_warnings()
	user = es.getcmduserid()
	steamid = es.getplayersteamid(user)
	if es.getplayersteamid(user) in banlist:
		es.tell(user, '[OCP] You are banned from ocp on this server...')
	else:
		if allow_selfreg == 1:
			if es.getargv(1) == selfreg_pw:
				adminsdict[es.getplayersteamid(user)] = (es.getplayername(user))
				es.tell(user,'You have successfully been added to the adminlist')
				write_admins()
			else:
				es.tell(user, '[OCP] Wrong password!')
				if warningsdict.has_key(steamid):
					if warningsdict[steamid] == limit:
						es.server.cmd('banid 0 ' + steamid + ' kick')
						es.server.cmd('writeid 0 ' + steamid)
					else:
						warningsdict[steamid] = warningsdict[steamid] + 1
				else:
					warningsdict[steamid] = 0
				write_warnings()
		else:
			es.tell(user, '[OCP] Self regristration not allowed')

def ocp_reg():
	read_admins()
	newsid = es.getargv(1)
	name = es.getargv(2)
	if not newsid.startswith('STEAM_'):
		if newsid.count(':') == 2:
			if newsid[0] in string.digits:
				newsid = 'STEAM_' + newsid
				if not adminsdict.has_key(newsid):
					adminsdict[newsid] = (name, linecount + 1)
					write_admins()
				else:
					es.dbgmsg(0, '[OCP] This user is already regristred as an admin as ' + adminsdict[newsid][1])
			else:
				es.dbgmsg(0, '[OCP] Syntax error!')
				es.dbgmsg(0, '[OCP] Use STEAM_1:2:3456789 or 1:2:3456789 as steam id format!')
				ocp_reg()
		else:
			es.dbgmsg(0, '[OCP] Syntax error!')
			es.dbgmsg(0, '[OCP] Use STEAM_1:2:3456789 or 1:2:3456789 as steam id format!')
			ocp_reg()
	elif newsid.count(':') == 2:
		if not adminsdict.has_key(newsid):
			adminsdict[newsid] = (name, linecount + 1)
			write_admins()
		else:
			es.dbgmsg(0, '[OCP] This user is already regristred as an admin as ' + adminsdict[newsid][1])
	write_admins()

def ocp_regplayer():
	global ocp_names, ocp_sid, ocp, adminsdict, linecount
	playerlist = playerlib.getUseridList('#all')
	c_names = []
	c_sid = []
	libplayer = ''
	x = 0
	read_admins()
	es.dbgmsg(0, '[OCP] Choose a player:')
	for player in playerlist:
		if not es.isbot(player):
			libplayer = playerlib.getPlayer(player)
			if not adminsdict.has_key(libplayer.get('steamid')):
				ocp_names.append(libplayer.get('name'))
				ocp_sid.append(libplayer.get('steamid'))
				x = x + 1
				es.dbgmsg(0,'[OCP] c' + str(x) + ': ' + str(libplayer.get('name')))
	if len(ocp_sid) == 0:
		es.dbgmsg(0, '[OCP] No player on the server that can be added to the adminslist!')
	es.dbgmsg(0, '[OCP] c0: Cancel')
		
def ocp_choice():
	global ocp_sid, ocp_names, adminsdict, linecount, ocp, banlist
	choice = es.getargv(0)
	read_admins()
	adminname = ''
	if choice == 'c0':
		es.dbgmsg(0, 'Cancelled')
	else:
		choice = int(choice.replace('c','')) - 1
		if ocp == 'reg':
			if not len(ocp_sid) == 0:
				if not choice > len(ocp_sid):
					adminsdict[ocp_sid[choice]] = (ocp_names[choice], linecount + 1)
					es.dbgmsg(0, '[OCP] ' + ocp_names[choice] + ' added to the adminlist')
					write_admins()
				else:
					es.dbgmsg(0, '[OCP] Invalid choice, try again!')
					es.dbgmsg(0, '')
					ocp_regplayer()
				ocp_sid = []
				ocp_names = []
		elif ocp == 'unreg':
			if not len(ocp_sid) == 0:
				if not choice > len(ocp_sid):
					adminname = adminsdict[ocp_sid[choice]][0]
					del adminsdict[ocp_sid[choice]]
					es.dbgmsg(0, '[OCP] ' + adminname + ' removed from adminlist')
					write_admins()
				else:
					es.dbgmsg(0, '[OCP] Invalid choice, try again!')
					es.dbgmsg(0, '')
				ocp_sid = []
		elif ocp == 'unban':
			if not len(banlist) == 0:
				if not choice > len(banlist):
					del banlist[choice]
					f = open(banfile,'wb')
					pickle.dump(banlist,f)
					f.close()
					es.dbgmsg(0,'[OCP] Successfully removed from banlist')
	ocp = ''
	
def ocp_unreg():
	global adminsdict, linecount, ocp, ocp_sid
	read_admins()
	ocp = 'unreg'
	es.dbgmsg(0, '[OCP] Choose an admin:')
	x = 1
	ocp_sid = []
	for a in adminsdict:
		es.dbgmsg(0,'[OCP] c' + str(x) + ': ' + str(adminsdict[a][0]))
		ocp_sid.append(a)
		x = x + 1
	if len(adminsdict) == 0:
		es.dbgmsg(0, '[OCP] No admins in the file!')
	es.dbgmsg(0, '[OCP] c0: Cancel')
def unban():
	global ocp
	ocp = 'unban'
	get_banlist()
	x = 1
	es.dbgmsg(0,'[OCP] Choose a steamid to unban:')
	for ban in banlist:
		es.dbgmsg(0,'[OCP] c' + str(x) + ': ' + str(ban))
		x = x + 1
	es.dbgmsg(0,'[OCP] c0: Cancel')
	
def ban():
	get_banlist()
	banlist.append(es.getargv(1))
	f = open(banfile,'wb')
	pickle.dump(banlist,f)
	f.close()
	es.dbgmsg(0,'[OCP] Successfully added ' + es.getargv(1) + ' to the banlist')
	
def get_configs():
	global clantaglist, limit, allow_selfreg, selfreg_pw, adminfile
	es.dbgmsg(0, '[OCP] No config file existing, writing new file...')
	default_configs = urllib2.urlopen("http://www.gkclan.com/members/uploads/01112@ocp_default_configs.cfg").read()
	default_configs = default_configs.replace('\r','')
	tempfile = open(cfgfile, 'w')
	tempfile.write(default_configs)
	tempfile.close()
	clantaglist = []
	allow_selfreg = 0
	adminfile = 'cfg/admins.txt'
	limit = 5
	es.dbgmsg(0, '[OCP] Config file written and default configs loaded...')
	
def configs():
	global clantaglist, limit, allow_selfreg, selfreg_pw, adminfile
	tempfile = open(cfgfile, 'r')
	templines = tempfile.read().splitlines()
	tempfile.close()
	lines = []
	templist = []
	clantaglist = []
	limit = None
	allow_selfreg = None
	selfreg_pw = None
	adminfile = None
	var = ''
	value = ''
	for t in templines:
		lines.append(t)
	for l in lines:
		if not l.startswith('//'):
			try:
				temp = l.index('//')
				temp = l.split('//')
				temp2 = temp[0]
			except ValueError:
				temp2 = l
			temp3 = temp2.split('=', 1)
			var = temp3[0].strip()
			value = temp3[1]
			if var == 'clantags':
				try:
					value.index(',,,')
					temp3 = value.split(',,,')
					for t in temp3:
						templist.append(t)
				except ValueError:
					templist.append(value)
				for t in templist:
					clantaglist.append(t)
					clantaglist.append(t.upper())
					clantaglist.append(t.lower())
					clantaglist.append(t.strip())
			elif var == 'limit':
				limit = value.replace(' ','')
			elif var == 'allow_selfreg':
				if int(value) in [1,0]:
					allow_selfreg = int(value)
				else:
					allow_selfreg = 0
					es.dbgmsg(0, '[OCP] Invalid value for allow_selfreg, set to default (0)')
			elif var == 'selfreg_pw':
				selfreg_pw = value.replace(' ','')
			elif var == 'adminfile':
				path = es.getAddonPath('')
				path = path.replace('\\','/')
				path = path.replace('addons/eventscripts/', '')
				path = path + value.replace("'","")
				path = path.replace(' ','')
				if os.path.lexists(path):
					adminfile = path
				else:
					es.dbgmsg(0, '[OCP] Invalid adminfile path, no admins set')
			else:
				es.dbgmsg(0, '[OCP] Invalid configs, shutting down')
				es.unload('ocp')
	if adminfile == None:
		es.dbgmsg(0, '[OCP] Error reading the adminfile from the configs, shutting down')
		es.unload('ocp')
	elif selfreg_pw == None:
		es.dbgmsg(0, '[OCP] Error getting the selfreg_pw from the configs, shutting down')
		es.unload('ocp')
	elif clantaglist == []:
		es.dbgmsg(0, '[OCP] Error getting the clantag list from the configs, shutting down')
		es.unload('ocp')
	elif allow_selfreg == None:
		es.dbgmsg(0, '[OCP] Error getting the value for allow_selfreg, shutting down')
		es.unload('ocp')
	elif limit == None:
		es.dbgmsg(0, '[OCP] Error getting the value for limit, shutting down')
		es.unload('ocp')

def get_banlist():
	global banlist
	f = open(banfile,'rb')
	banlist = pickle.load(f)
	f.close()
	
def update():
	read_admins()
	user = es.getcmduserid()
	steamid = es.getplayersteamid(user)
	if adminsdict.has_key(steamid):
		ojiiupdater.popup(info,updateurl,user)